using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Printing;
using RootPro.RootProCAD;

namespace RCAddInMultiPrintCS
{
    public partial class Form1 : Form
    {
        RootProCADApplication app = null;
        private int selectedPaperRowKind = -1;  // IĂp
        private List<int> paperRowKinds = new List<int>();        // pID̔z


        public Form1(RootProCADApplication app)
        {
            this.app = app;

            InitializeComponent();
        }

        /// <summary>
        /// tH[ǂݍ܂ꂽƂ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            // CXg[Ăv^̈ꗗR{{bNXɒǉ
            PrinterSettings.StringCollection printers = PrinterSettings.InstalledPrinters;
            System.Drawing.Printing.PrintDocument pd = new PrintDocument();
            string defaultPrinterName = pd.PrinterSettings.PrinterName;
            foreach (string printerName in printers)
            {
                int index = printerComboBox.Items.Add(printerName);

                if(printerName == defaultPrinterName)
                    printerComboBox.SelectedIndex = index;
            }

            if (printers.Count == 0)
            {
                MessageBox.Show("v^CXg[Ă܂B");
                printButton.Enabled = false;
                return;
            }
        }

        /// <summary>
        /// [t@C̒ǉ] {^NbNƂ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void addFileButton_Click(object sender, EventArgs e)
        {
            // }ʃt@Cǉ邽߂ɁAt@CI_CAO{bNX\
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            openFileDialog.Filter = "RootPro CAD }ʃt@C (*.rpcd;*.rpct;*.djc;*.dj2;*.djt)|*.rpcd;*.rpct;*.djc;*.dj2;*.djt";
            openFileDialog.FilterIndex = 1;
            openFileDialog.RestoreDirectory = true;
            openFileDialog.Multiselect = true;
            openFileDialog.Title = "}ʃt@Cǉ";

            if(openFileDialog.ShowDialog() == DialogResult.OK)
            {
                // Iꂽt@CXgr[ɒǉ
                string[] fileNames = openFileDialog.FileNames;
                foreach (string fileName in fileNames)
                {
                    ListViewItem listViewItem = fileListView.Items.Add(System.IO.Path.GetFileName(fileName));
                    listViewItem.SubItems.Add(System.IO.Path.GetDirectoryName(fileName));
                    listViewItem.Name = fileName;
                }
            }
        }

        /// <summary>
        /// [t@C̍폜] {^NbNƂ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void removeFileButton_Click(object sender, EventArgs e)
        {
            if (fileListView.SelectedItems.Count == 0)
            {
                MessageBox.Show("[t@Cꗗ] ō폜}ʃt@CIĂB");
                return;
            }

            foreach (ListViewItem listViewItem in fileListView.SelectedItems)
            {
                listViewItem.Remove();
            }
        }

        /// <summary>
        /// [] {^NbNƂ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void closeButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        /// <summary>
        /// [}ʂ̈ݒgp] `FbN{bNX̃`FbNԂύXꂽƂ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void useDocSettingCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            bool useDocSetting = useDocSettingCheckBox.Checked;

            monoPrintCheckBox.Enabled = !useDocSetting;
            paperComboBox.Enabled = !useDocSetting;
            portraitRadioButton.Enabled = !useDocSetting;
            landscapeRadioButton.Enabled = !useDocSetting;
            autoScaleRadioButton.Enabled = !useDocSetting;
            manualScaleRadioButton.Enabled = !useDocSetting;
            scaleTextBox.Enabled = !useDocSetting;
        }

        /// <summary>
        /// [v^] R{{bNX̑IύXꂽƂ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void printerComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            // pTCYR{{bNXNA
            paperComboBox.Items.Clear();

            // ۑĂpIDzNA
            paperRowKinds.Clear();

            // Iꂽv^Ŏgp\ȗpނ擾
            string printerName = (string)printerComboBox.SelectedItem;
            PrintDocument pd = new PrintDocument();
            pd.PrinterSettings.PrinterName = printerName;
            PrinterSettings.PaperSizeCollection paperSizes = pd.PrinterSettings.PaperSizes;

            // pTCYR{{bNXɗpނǉ
            foreach (PaperSize paperSize in paperSizes)
            {
                int index = paperComboBox.Items.Add(paperSize.PaperName);

                // pIDۑĂ
                paperRowKinds.Add(paperSize.RawKind);
            }

            // OIĂpꍇ́A̗pI
            bool paperSelected = false;
            for(int i = 0; i < paperRowKinds.Count; i++)
            {
                if (paperRowKinds[i] == selectedPaperRowKind)
                {
                    paperComboBox.SelectedIndex = i;
                    paperSelected = true;
                    break;
                }
            }

            // OIĂpȂꍇ́AftHg̗pI
            if (!paperSelected)
            {
                int defaultPaperRowKind = pd.DefaultPageSettings.PaperSize.RawKind;

                for (int i = 0; i < paperRowKinds.Count; i++)
                {
                    if (paperRowKinds[i] == defaultPaperRowKind)
                    {
                        paperComboBox.SelectedIndex = i;
                        break;
                    }
                }
            }
        }

        /// <summary>
        /// pTCYR{{bNX̑IύXꂽƂ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void paperComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Iꂽp̗pIDۑ
            int index = paperComboBox.SelectedIndex;
            if (index >= 0)
            {
                selectedPaperRowKind = paperRowKinds[index];
            }
            else
            {
                selectedPaperRowKind = -1;
            }
        }

        /// <summary>
        /// [s] {^NbNꂽƂ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void printButton_Click(object sender, EventArgs e)
        {
            if(fileListView.Items.Count == 0)
            {
                MessageBox.Show("}ʃt@CǉĂB");
                return;
            }

            // Xgr[̔wiFNA
            fileListView.Focus();
            foreach(ListViewItem listViewItem in fileListView.Items)
            {
                listViewItem.BackColor = fileListView.BackColor;
            }
            fileListView.Update();
            
            // v^̃`FbN
            if(printerComboBox.SelectedIndex < 0)
            {
                MessageBox.Show("v^IĂ܂B");
                return;
            }
            string printerName = (string)printerComboBox.SelectedItem;


            // ݒ擾
            bool useDocSetting = useDocSettingCheckBox.Checked;
            bool monoPrint = monoPrintCheckBox.Checked;
            bool landscape = landscapeRadioButton.Checked;
            bool autoScale = autoScaleRadioButton.Checked;
            double scale = 100.0;
            if (!autoScale)
            {
                if (!System.Double.TryParse(scaleTextBox.Text, out scale) || scale <= 0)
                {
                    MessageBox.Show("{̎w肪ԈĂ܂B");
                    return;
                }
            }

            // p^Cṽ`FbN
            if(useDocSetting && selectedPaperRowKind < 0)
            {
                MessageBox.Show("pIĂ܂B");
                return;
            }


            Cursor.Current = System.Windows.Forms.Cursors.WaitCursor;

            foreach (ListViewItem listViewItem in fileListView.Items)
            {
                // ݈̃XgACeIԂɂ
                fileListView.SelectedItems.Clear();
                listViewItem.Selected = true;
                listViewItem.Focused = true;
                fileListView.Update();

                // }ʃt@C̃t@CpX擾
                string filePath = listViewItem.Name;

                Document doc = null;
                bool docOpened = false;

                // }ʃt@CłɊJĂ邩ׂ
                DocumentCollection docs = app.Documents;
                int docCount = docs.Count;
                for (int i = 0; i < docCount; i++)
                {
                    if (String.Compare(filePath, docs[i].FullName, true) == 0)
                    {
                        doc = docs[i];
                        docOpened = true;
                        break;
                    }
                }

                // }ʃt@CJĂȂȂJ
                if (!docOpened)
                {
                    doc = docs.Open(filePath);
                }
                if (doc == null)
                    continue;


                // Ǝ̐ݒgpȂA}ʂ̈ݒύX
                if (!useDocSetting)
                {
                    doc.PrintSettings.PaperSizeKind = selectedPaperRowKind;
                    doc.PrintSettings.PrintBlackAndWhite = monoPrint;
                    doc.PrintSettings.Landscape = landscape;
                    doc.PrintSettings.ScaleMode = autoScale ? PrintScaleMode.FitToPaper : PrintScaleMode.Scale;
                    doc.PrintSettings.Scale = scale * 0.01;
                }


                // }ʓ̗p
                int drawingCount = doc.Drawings.Count;
                for (int i = 0; i < drawingCount; i++)
                {
                    Drawing drawing = doc.Drawings[i];

                    // p݈̂
                    if (!(drawing is Paper))
                        continue;

                    // ȂݒɂȂĂp͈Ȃ
                    if (!drawing.Printable)
                        continue;

                    doc.CurrentDrawing = drawing;

                    // s
                    doc.PrintOut(printerName, 1);
                }


                // ̂߂ɐ}ʃt@CJꍇ́AŌɕ
                if (!docOpened)
                {
                    doc.Close();
                }

                // ɁAXgACe̔wiFO[ɂ
                listViewItem.BackColor = Color.LightGray;
            }

            fileListView.SelectedItems.Clear();
        }
    }
}